Constructor item_controller()
	For i As Integer=0 To ITEM_MAX_COUNT-1
		This.item_list(i).parent=@This
	Next i
End Constructor

Private Sub item_controller.define_pc (ByVal _pc As snake_controller Ptr)
	This._pc=_pc
	For i As Integer=0 To ITEM_MAX_COUNT-1
		This.item_list(i)._pc=_pc
	Next i
End Sub

Property item_controller.getItem (ByRef _id As Integer) As item Ptr
	Return @This.item_list(This.item_queue(_id))
End Property
Private Sub item_controller.doStep()
	This.item_removal_queue_empty()
	Dim As Integer hasfood=0
	For i As Integer=0 To This.item_queue_count-1
		If (This.item_list(This.item_queue(i)).setting=ITEM_SNACK)Then
			hasfood=-1
			i=ITEM_MAX_COUNT
		EndIf
	Next i
	
	If (Not hasfood)Then
		This.item_enqueue(ITEM_SNACK)
	EndIf
	
	For i As Integer=0 To This.item_queue_count-1
		If (This.item_list(This.item_queue(i)).bonus)Then
			This.item_list(This.item_queue(i)).counter-=1
			If (This.item_list(This.item_queue(i)).counter<0)Then
				This.item_removal_enqueue(This.item_queue(i))
			EndIf
		EndIf
		
		This.item_list(This.item_queue(i)).draw()
	Next i
End Sub

Private Sub item_controller.item_enqueue(ByRef _setting As Integer)
	If (This.item_queue_count=ITEM_MAX_COUNT)Then
		Print "NO AVAILABLE SPOTS IN ITEM QUEUE!"
		'I could add a queue to handle the overflows, but it would just be easier
		'to add more spots to the queue. Anyway, this game shouldn't need many spots.
		Exit Sub
	EndIf
	
	Dim As Integer available(ITEM_MAX_COUNT),available_count=ITEM_MAX_COUNT
	For i As Integer=0 To ITEM_MAX_COUNT-1
		available(i)=i
	Next i
	
	For i As Integer=0 To available_count-1
		For j As Integer=0 To This.item_queue_count-1
			If (This.item_queue(j)=available(i))Then
				available_count-=1
				For k As Integer=i To available_count-1
					available(k)=available(k+1)
				Next k
			EndIf
		Next j
	Next i
	
	This.item_queue(This.item_queue_count)=available(0)
	This.item_queue_count+=1
	This.item_list(available(0)).setDefaults(_setting)
	This.item_list(available(0)).placeRandomly()
End Sub

Private Sub item_controller.item_queue_dequeue(ByRef _id As Integer)
	Dim As Integer sid=0
	For i As Integer=0 To This.item_queue_count-1
		If (This.item_queue(i)=_id)Then
			sid=i
			i=ITEM_MAX_COUNT
		EndIf
	Next i
	
	This.item_queue_count-=1
	For i As Integer=sid To This.item_queue_count-1
		This.item_queue(i)=This.item_queue(i+1)
	Next i
End Sub

Private Sub item_controller.item_removal_enqueue(ByRef _id As Integer)
	For i As Integer=0 To This.item_removal_queue_count-1
		If (This.item_removal_queue(i)=_id)Then
			Exit Sub
		EndIf
	Next i
	This.item_removal_queue(This.item_removal_queue_count)=_id
	This.item_removal_queue_count+=1
End Sub

Private Sub item_controller.item_removal_queue_empty()
	For i As Integer=0 To This.item_removal_queue_count-1
		For j As Integer=0 To This.item_queue_count-1
			If (This.item_queue(j)=This.item_removal_queue(i))Then 
				This.item_queue_dequeue(This.item_queue(j))
			EndIf
		Next j
	Next i
	This.item_removal_queue_count=0
End Sub