Constructor snake_controller()
	For i As Integer=0 To PLAYER_MAX_COUNT-1
		This.player(i).parent=@This
	Next i
End Constructor

Private Sub snake_controller.define_ic(ByVal _ic As item_controller Ptr)
	This._ic=_ic
	For i As Integer=0 To PLAYER_MAX_COUNT-1
		This.player(i)._ic=_ic
	Next i
End Sub

Private Sub snake_controller.define_obstacles(ByVal _oc As Integer Ptr, ByVal _ol As obstacle Ptr)
	This.obstacle_count=_oc
	This.obstacle_list=_ol
	For i As Integer=0 To PLAYER_MAX_COUNT-1
		This.player(i).obstacle_count=_oc
		This.player(i).obstacle_list=_ol
	Next i
End Sub

Private Sub snake_controller.death_enqueue(ByRef _pnum As Integer)
	This.death_queue(This.death_count)=_pnum
	This.death_count+=1
End Sub

Private Sub snake_controller.death_queue_empty()
	For i As Integer=0 To This.death_count-1
		This.player(This.death_queue(i)).dead=-1
		This.player(This.death_queue(i)).triggerDie()
		This.triggerDie(This.player(This.death_queue(i)))
	Next i
	This.death_count=0
End Sub

Private Sub snake_controller.triggerMove(ByRef _player As snake)
'	'do stuff when moved
End Sub

Private Sub snake_controller.triggerDie(ByRef _player As snake)
	'do stuff when die
	Print _player.name & " died!"
End Sub

Private Sub snake_controller.triggerEat(ByRef _player As snake, ByRef _item As item)
	'do stuff when eat
	Static count As Integer=0
	count+=1
	If (_item.bonus)Then 
		Print _player.name & " ate BONUS #" & count
	Else
		Print _player.name & " ate food #" & count
	EndIf
	If (count Mod 10=0)Then
		(*This._ic).item_enqueue(Int(Rnd*3)+1)
	EndIf
End Sub

Private Sub snake_controller.triggerDigest(ByRef _player As snake)
	'do stuff when digest
End Sub

Private Sub snake_controller.addPlayer(ByRef _name As String, ByRef _red As UByte, ByRef _green As UByte, ByRef _blue As UByte, ByRef _x As Integer, ByRef _y As Integer, ByRef _direction As Integer)
	'add player
	If (This.player_count>=PLAYER_MAX_COUNT)Then
		Print "TRYING TO ADD MORE PLAYERS THAN ALLOWED!"
		Exit Sub
	EndIf
	
	This.player(This.player_count).pnum=This.player_count
	This.player(This.player_count).name=_name
	This.player(This.player_count).color(0)=_red
	This.player(This.player_count).color(1)=_green
	This.player(This.player_count).color(2)=_blue
	This.player(This.player_count).body(0,0)=_x
	This.player(This.player_count).body(0,1)=_y
	This.player(This.player_count).direction=_direction
	
	This.player(This.player_count).speed=This.speed0
	This.player(This.player_count).length=This.length0
	
	This.player(This.player_count).setup()
	
	This.player_count+=1
End Sub

Private Sub snake_controller.handleEvents(ByRef _event As SDL_Event)
	For i As Integer=0 To This.player_count-1
		This.player(i).handleEvents(_event)
	Next i
End Sub

Private Sub snake_controller.doStep()
	This.death_queue_empty()
	
	For i As Integer=0 To This.player_count-1
		This.player(i).doStep()
	Next i
	For i As Integer=0 To This.player_count-1
		If (Not This.player(i).dead)Then This.player(i).checkCollision()
	Next i

	This.allDead=-1
	For i As UByte=0 To This.player_count-1
		This.allDead And= This.player(i).dead
	Next i 
End Sub

Private Sub snake_controller.drawScores()
	Dim As String temp
	For i As Integer=0 To This.player_count-1
		temp+="[" & This.player(i).name & ":" & This.player(i).score^2 & "] "
	Next i
	SDL_WM_SetCaption(temp,"")
End Sub

